/* $Id: Hash_map_base.h,v 1.3 2003/03/12 19:30:18 lergnom Exp $ -*- C++ -*-
 * 
 * libbpfl - Bayesian Probability Filtering Library
 * Copyright (C) 2003 Anthony Ventimiglia
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */
#ifndef BPF__HASH_MAP_BASE
#define BPF__HASH_MAP_BASE

#ifdef __BPF_BUILD
#include "common.h"
#endif 

#include <cstdlib>

namespace bpf { 
///This is a small base class for the Hash_map template.
///I've used it to define the two static consts used in the Hash_map template.
///
///@todo bring the required interface methods from Hash_map into here,
///so this can be used as an abstract base.  
class Hash_map_base 
{
public:
    virtual ~Hash_map_base () {}
    
    ///Table index type.
    ///This is here so I can easily chage the type used to index into the
    ///table.
    typedef std::size_t tablesize;


protected:
    static const tablesize size_lookup_table[];
    static const tablesize lookup_table_size;
};


};				// namespace bpf

#endif // BPF__HASH_MAP_BASE
